diff --git a/src/tls_wrappers/api/tls_wrapper_verify_certificate_extension.c b/src/tls_wrappers/api/tls_wrapper_verify_certificate_extension.c
index e1a70e6..50c61e3 100644
--- a/src/tls_wrappers/api/tls_wrapper_verify_certificate_extension.c
+++ b/src/tls_wrappers/api/tls_wrapper_verify_certificate_extension.c
@@ -14,11 +14,13 @@
 #include "internal/dice.h"
 
 #include <rats-tls/csv.h>
+#include <rats-tls/virtcca.h>
 // clang-format off
 #ifdef SGX
 #include "sgx_report.h"
 #endif
-#include "sgx_quote_3.h"
+// FixMe: "sgx_quote_3.h"
+// #include "sgx_quote_3.h"
 // clang-format on
 
 tls_wrapper_err_t
@@ -34,26 +36,17 @@ tls_wrapper_verify_evidence(tls_wrapper_ctx_t *tls_ctx, attestation_evidence_t *
 	    !tls_ctx->rtls_handle->verifier->opts->verify_evidence)
 		return -TLS_WRAPPER_ERR_INVALID;
 
-	if (!(tls_ctx->rtls_handle->flags & RATS_TLS_CONF_FLAGS_VERIFIER_ENFORCED)) {
-		char *type;
-
-		if (evidence->type[0])
-			type = evidence->type;
-		else
-			type = "nullverifier";
-
-		if (strcmp(tls_ctx->rtls_handle->verifier->opts->type, type)) {
-			RTLS_DEBUG("Requesting verifier '%s' against current verifier '%s'\n", type,
-				   tls_ctx->rtls_handle->verifier->opts->name);
-
-			rats_tls_err_t tlserr = rtls_verifier_select(
-				tls_ctx->rtls_handle, type, tls_ctx->rtls_handle->config.cert_algo);
-			if (tlserr != RATS_TLS_ERR_NONE) {
-				RTLS_ERR(
-					"the verifier selecting err %#x during verifying cert extension\n",
-					tlserr);
-				return -TLS_WRAPPER_ERR_INVALID;
-			}
+	if (strcmp(tls_ctx->rtls_handle->verifier->opts->type, evidence->type) &&
+	    !(tls_ctx->rtls_handle->flags & RATS_TLS_CONF_FLAGS_VERIFIER_ENFORCED)) {
+		RTLS_WARN("type doesn't match between verifier '%s' and evidence '%s'\n",
+			  tls_ctx->rtls_handle->verifier->opts->name, evidence->type);
+		rats_tls_err_t tlserr =
+			rtls_verifier_select(tls_ctx->rtls_handle, evidence->type,
+					     tls_ctx->rtls_handle->config.cert_algo);
+		if (tlserr != RATS_TLS_ERR_NONE) {
+			RTLS_ERR("the verifier selecting err %#x during verifying cert extension\n",
+				 tlserr);
+			return -TLS_WRAPPER_ERR_INVALID;
 		}
 	}
 
@@ -70,7 +63,10 @@ tls_wrapper_verify_evidence(tls_wrapper_ctx_t *tls_ctx, attestation_evidence_t *
 tls_wrapper_err_t tls_wrapper_verify_certificate_extension(
 	tls_wrapper_ctx_t *tls_ctx,
 	const uint8_t *pubkey_buffer /* in SubjectPublicKeyInfo format */,
-	size_t pubkey_buffer_size, uint8_t *evidence_buffer /* optional, for nullverifier */,
+	size_t pubkey_buffer_size, 
+	const uint8_t *nonce_buffer,
+	size_t nonce_buffer_size,
+	uint8_t *evidence_buffer /* optional, for nullverifier */,
 	size_t evidence_buffer_size, uint8_t *endorsements_buffer /* optional */,
 	size_t endorsements_buffer_size)
 {
@@ -84,19 +80,20 @@ tls_wrapper_err_t tls_wrapper_verify_certificate_extension(
 	size_t custom_claims_length = 0;
 
 	RTLS_DEBUG(
-		"tls_ctx: %p, pubkey_buffer: %p, pubkey_buffer_size: %zu, evidence_buffer: %p, evidence_buffer_size: %zu, endorsements_buffer: %p, endorsements_buffer_size: %zu\n",
-		tls_ctx, pubkey_buffer, pubkey_buffer_size, evidence_buffer, evidence_buffer_size,
+		"tls_ctx: %p, pubkey_buffer: %p, pubkey_buffer_size: %zu, nonce_buffer: %p, nonce_buffer_size: %zu, "
+		"evidence_buffer: %p, evidence_buffer_size: %zu, endorsements_buffer: %p, endorsements_buffer_size: %zu\n",
+		tls_ctx, pubkey_buffer, pubkey_buffer_size, nonce_buffer, nonce_buffer_size, evidence_buffer, evidence_buffer_size,
 		endorsements_buffer, endorsements_buffer_size);
 
 	if (!tls_ctx || !tls_ctx->rtls_handle || !tls_ctx->rtls_handle->verifier ||
 	    !tls_ctx->rtls_handle->verifier->opts ||
-	    !tls_ctx->rtls_handle->verifier->opts->verify_evidence || !pubkey_buffer)
+	    !tls_ctx->rtls_handle->verifier->opts->verify_evidence || !pubkey_buffer || !nonce_buffer)
 		return -TLS_WRAPPER_ERR_INVALID;
 
 	/* Get evidence struct and claims_buffer from evidence_buffer. */
 	if (!evidence_buffer) {
 		/* evidence_buffer is empty, which means that the other party is using a non-dice certificate or is using a nullattester */
-		RTLS_WARN("No evidence available in peer's certificate\n");
+		RTLS_WARN("there is no evidence buffer in peer's certificate.\n");
 		memset(&evidence, 0, sizeof(attestation_evidence_t));
 	} else {
 		enclave_verifier_err_t d_ret = dice_parse_evidence_buffer_with_tag(
@@ -179,9 +176,11 @@ tls_wrapper_err_t tls_wrapper_verify_certificate_extension(
 	if (claims_buffer) {
 		hash_algo_t pubkey_hash_algo = HASH_ALGO_RESERVED;
 		uint8_t pubkey_hash[MAX_HASH_SIZE];
+		uint8_t nonce[MAX_NONCE_SIZE];
+		size_t nonce_size = 0;
 		enclave_verifier_err_t d_ret = dice_parse_claims_buffer(
 			claims_buffer, claims_buffer_size, &pubkey_hash_algo, pubkey_hash,
-			&custom_claims, &custom_claims_length);
+			nonce, &nonce_size, &custom_claims, &custom_claims_length);
 		free(claims_buffer);
 		claims_buffer = NULL;
 		if (d_ret != ENCLAVE_VERIFIER_ERR_NONE) {
@@ -229,6 +228,25 @@ tls_wrapper_err_t tls_wrapper_verify_certificate_extension(
 			ret = TLS_WRAPPER_ERR_INVALID;
 			goto err;
 		}
+
+		/* Verify nonce */
+		RTLS_DEBUG("check nonce. nonce_buffer_size: %zu, nonce size: %zu\n", nonce_buffer_size, nonce_size);
+		RTLS_DEBUG("The nonce in claim [%zu] %02x%02x%02x%02x%02x%02x%02x%02x...\n",
+			   nonce_size, nonce[0], nonce[1], nonce[2], nonce[3],
+			   nonce[4], nonce[5], nonce[6], nonce[7]);
+
+		if (nonce_buffer_size != nonce_size) {
+			RTLS_ERR("unmatched nonce lenth in claims buffer\n");
+			ret = TLS_WRAPPER_ERR_INVALID;
+			goto err;
+		}
+		
+		if (memcmp(nonce_buffer, nonce, nonce_buffer_size)) {
+			RTLS_ERR("unmatched nonce value in claims buffer\n");
+			ret = TLS_WRAPPER_ERR_INVALID;
+			goto err;
+		} 
+
 	}
 
 	/* Verify evidence struct via user_callback */
@@ -237,16 +255,17 @@ tls_wrapper_err_t tls_wrapper_verify_certificate_extension(
 	ev.custom_claims = custom_claims;
 	ev.custom_claims_length = custom_claims_length;
 	if (!strncmp(evidence.type, "sgx_ecdsa", sizeof(evidence.type))) {
-		sgx_quote3_t *quote3 = (sgx_quote3_t *)evidence.ecdsa.quote;
-
-		ev.sgx.mr_enclave = (uint8_t *)quote3->report_body.mr_enclave.m;
-		ev.sgx.mr_signer = quote3->report_body.mr_signer.m;
-		ev.sgx.product_id = quote3->report_body.isv_prod_id;
-		ev.sgx.security_version = quote3->report_body.isv_svn;
-		ev.sgx.attributes = (uint8_t *)&(quote3->report_body.attributes);
-		ev.type = SGX_ECDSA;
-		ev.quote = (char *)quote3;
-		ev.quote_size = sizeof(sgx_quote3_t);
+		// FixMe: "sgx_quote_3.h"
+		// sgx_quote3_t *quote3 = (sgx_quote3_t *)evidence.ecdsa.quote;
+
+		// ev.sgx.mr_enclave = (uint8_t *)quote3->report_body.mr_enclave.m;
+		// ev.sgx.mr_signer = quote3->report_body.mr_signer.m;
+		// ev.sgx.product_id = quote3->report_body.isv_prod_id;
+		// ev.sgx.security_version = quote3->report_body.isv_svn;
+		// ev.sgx.attributes = (uint8_t *)&(quote3->report_body.attributes);
+		// ev.type = SGX_ECDSA;
+		// ev.quote = (char *)quote3;
+		// ev.quote_size = sizeof(sgx_quote3_t);
 	}
 #if 0
 	else if (!strncmp(evidence.type, "tdx_ecdsa", sizeof(evidence.type))) {
@@ -284,6 +303,12 @@ tls_wrapper_err_t tls_wrapper_verify_certificate_extension(
 		ev.quote_size = sizeof(*report);
 	}
 
+	else if (!strncmp(evidence.type, "virtcca", sizeof(evidence.type))) {
+		ev.cca.evidence = (uint8_t *)tls_ctx->rtls_handle->verifier->verifier_private;
+		ev.cca.evidence_sz = 4104;
+		ev.type = CCA;
+	}
+
 	if (tls_ctx->rtls_handle->user_callback) {
 		int rc = tls_ctx->rtls_handle->user_callback(&ev);
 		if (!rc) {
diff --git a/src/tls_wrappers/nulltls/negotiate.c b/src/tls_wrappers/nulltls/negotiate.c
index 028d78e..b9b6a66 100644
--- a/src/tls_wrappers/nulltls/negotiate.c
+++ b/src/tls_wrappers/nulltls/negotiate.c
@@ -22,8 +22,10 @@ tls_wrapper_err_t nulltls_negotiate(tls_wrapper_ctx_t *ctx, int fd)
 
 		size_t pubkey_buffer_size = 0;
 		uint8_t pubkey_buffer[pubkey_buffer_size];
+		size_t nonce_buffer_size = 0;
+		uint8_t nonce_buffer[nonce_buffer_size];
 		tls_wrapper_err_t err = tls_wrapper_verify_certificate_extension(
-			ctx, pubkey_buffer, pubkey_buffer_size, NULL, 0, NULL, 0);
+			ctx, pubkey_buffer, pubkey_buffer_size, nonce_buffer, nonce_buffer_size, NULL, 0, NULL, 0);
 		if (err != TLS_WRAPPER_ERR_NONE) {
 			RTLS_ERR("ERROR: failed to verify certificate extension\n");
 			return err;
diff --git a/src/tls_wrappers/nulltls/receive.c b/src/tls_wrappers/nulltls/receive.c
index fd0ea12..86ee259 100644
--- a/src/tls_wrappers/nulltls/receive.c
+++ b/src/tls_wrappers/nulltls/receive.c
@@ -6,8 +6,8 @@
 
 #include <unistd.h>
 #include <rats-tls/log.h>
+#include <internal/core.h>
 #include <rats-tls/tls_wrapper.h>
-#include "internal/core.h"
 
 tls_wrapper_err_t nulltls_receive(tls_wrapper_ctx_t *ctx, void *buf, size_t *buf_size)
 {
diff --git a/src/tls_wrappers/nulltls/transmit.c b/src/tls_wrappers/nulltls/transmit.c
index e450679..08f16e0 100644
--- a/src/tls_wrappers/nulltls/transmit.c
+++ b/src/tls_wrappers/nulltls/transmit.c
@@ -7,7 +7,7 @@
 #include <unistd.h>
 #include <rats-tls/log.h>
 #include <rats-tls/tls_wrapper.h>
-#include "internal/core.h"
+#include <internal/core.h>
 
 tls_wrapper_err_t nulltls_transmit(tls_wrapper_ctx_t *ctx, void *buf, size_t *buf_size)
 {
diff --git a/src/tls_wrappers/openssl/CMakeLists.txt b/src/tls_wrappers/openssl/CMakeLists.txt
index 2bc8da8..bb7900d 100644
--- a/src/tls_wrappers/openssl/CMakeLists.txt
+++ b/src/tls_wrappers/openssl/CMakeLists.txt
@@ -27,6 +27,7 @@ set(SOURCES cleanup.c
             receive.c
             transmit.c
             use_cert.c
+            get_nonce.c
             use_privkey.c
             x509_openssl10x.c
             )
diff --git a/src/tls_wrappers/openssl/get_nonce.c b/src/tls_wrappers/openssl/get_nonce.c
new file mode 100644
index 0000000..ed7de05
--- /dev/null
+++ b/src/tls_wrappers/openssl/get_nonce.c
@@ -0,0 +1,49 @@
+#include <rats-tls/log.h>
+#include <rats-tls/tls_wrapper.h>
+#include "openssl.h"
+#include <string.h>
+
+tls_wrapper_err_t openssl_tls_get_nonce(tls_wrapper_ctx_t *ctx, bool peer, void *buf, size_t *buf_size)
+{
+    RTLS_DEBUG("ctx: %p, peer: %d, buf: %p, buf_size: %zu\n", ctx, peer, buf, *buf_size);
+    size_t len;
+
+	if (!ctx || !buf || !buf_size)
+		return -TLS_WRAPPER_ERR_INVALID;
+
+    unsigned char *buffer = (unsigned char *)buf;
+	openssl_ctx_t *ssl_ctx = (openssl_ctx_t *)ctx->tls_private;
+	if (ssl_ctx == NULL || ssl_ctx->ssl == NULL) {
+        RTLS_ERR("no ssl_ctx or ssl available\n");
+        return -TLS_WRAPPER_ERR_NONCE; 
+    }
+	
+    /* Read self or peer random number
+       SERVER && peer=True  : client
+       CLIENT && peer=False : client
+       SERVER && peer=False : server
+       CLIENT && peer=True  : server
+    */
+    unsigned long conf_flags = ctx->conf_flags;
+    if (((conf_flags & RATS_TLS_CONF_FLAGS_SERVER) && peer) ||
+        (!(conf_flags & RATS_TLS_CONF_FLAGS_SERVER) && !peer)) {
+        len = SSL_get_client_random(ssl_ctx->ssl, buffer, *buf_size);
+    } else {
+        len = SSL_get_server_random(ssl_ctx->ssl, buffer, *buf_size);
+    }
+
+    /* len can only be smaller or equal to buf_size */
+    *buf_size = len;
+
+    if (len > 0) {
+		RTLS_DEBUG(
+			"%s random number in hello [%zu] %02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x...\n",
+			peer ? "peer" : "self", *buf_size, buffer[0], buffer[1], buffer[2], buffer[3], buffer[4], buffer[5], 
+            buffer[6],	buffer[7], buffer[8], buffer[9], buffer[10], buffer[11], buffer[12], buffer[13], buffer[14], buffer[15]);
+    } else {
+        RTLS_ERR("SSL_get_*_random() failed\n");
+        return TLS_WRAPPER_ERR_NONCE;
+    }
+
+    return TLS_WRAPPER_ERR_NONE;
+}
\ No newline at end of file
diff --git a/src/tls_wrappers/openssl/main.c b/src/tls_wrappers/openssl/main.c
index c1c88fe..b108aa6 100644
--- a/src/tls_wrappers/openssl/main.c
+++ b/src/tls_wrappers/openssl/main.c
@@ -15,6 +15,8 @@ extern tls_wrapper_err_t openssl_tls_use_privkey(tls_wrapper_ctx_t *ctx, rats_tl
 						 void *privkey_buf, size_t privkey_len);
 extern tls_wrapper_err_t openssl_tls_use_cert(tls_wrapper_ctx_t *ctx,
 					      rats_tls_cert_info_t *cert_info);
+extern tls_wrapper_err_t openssl_tls_get_nonce(tls_wrapper_ctx_t *ctx, bool peer, 
+						  void *buf, size_t *buf_size);
 extern tls_wrapper_err_t openssl_tls_negotiate(tls_wrapper_ctx_t *, int fd);
 extern tls_wrapper_err_t openssl_tls_transmit(tls_wrapper_ctx_t *, void *, size_t *);
 extern tls_wrapper_err_t openssl_tls_receive(tls_wrapper_ctx_t *, void *, size_t *);
@@ -28,6 +30,7 @@ static tls_wrapper_opts_t openssl_opts = {
 	.init = openssl_tls_init,
 	.use_privkey = openssl_tls_use_privkey,
 	.use_cert = openssl_tls_use_cert,
+	.get_nonce = openssl_tls_get_nonce,
 	.negotiate = openssl_tls_negotiate,
 	.transmit = openssl_tls_transmit,
 	.receive = openssl_tls_receive,
diff --git a/src/tls_wrappers/openssl/negotiate.c b/src/tls_wrappers/openssl/negotiate.c
index 8657924..bee95c1 100644
--- a/src/tls_wrappers/openssl/negotiate.c
+++ b/src/tls_wrappers/openssl/negotiate.c
@@ -11,6 +11,7 @@
 #include "openssl.h"
 
 extern int verify_certificate(int preverify_ok, X509_STORE_CTX *store);
+extern int generate_certificate(SSL *ssl, void *ctx);
 
 tls_wrapper_err_t openssl_internal_negotiate(tls_wrapper_ctx_t *ctx, unsigned long conf_flags,
 					     int fd, int (*verify)(int, X509_STORE_CTX *))
@@ -37,9 +38,13 @@ tls_wrapper_err_t openssl_internal_negotiate(tls_wrapper_ctx_t *ctx, unsigned lo
 		SSL_CTX_set_verify(ssl_ctx->sctx, mode, verify);
 	}
 
+	/* Set certificate callback function to dynamically generate certificate */
+	SSL_CTX_set_cert_cb(ssl_ctx->sctx, generate_certificate, (void *) ctx);
+
 	SSL *ssl = SSL_new(ssl_ctx->sctx);
 	if (!ssl)
 		return -TLS_WRAPPER_ERR_NO_MEM;
+	ssl_ctx->ssl = ssl;
 
 	X509_STORE *cert_store = SSL_CTX_get_cert_store(ssl_ctx->sctx);
 	X509_STORE_set_ex_data(cert_store, openssl_ex_data_idx, ctx);
@@ -67,12 +72,10 @@ tls_wrapper_err_t openssl_internal_negotiate(tls_wrapper_ctx_t *ctx, unsigned lo
 				 SSL_get_error(ssl, err));
 		// TODO: handle result of SSL_get_error()
 		print_openssl_err_all(ssl, err);
-
+		ssl_ctx->ssl = NULL;
 		return OPENSSL_ERR_CODE(err);
 	}
 
-	ssl_ctx->ssl = ssl;
-
 	if (conf_flags & RATS_TLS_CONF_FLAGS_SERVER)
 		RTLS_DEBUG("success to negotiate\n");
 	else
diff --git a/src/tls_wrappers/openssl/un_negotiate.c b/src/tls_wrappers/openssl/un_negotiate.c
index 20acd4f..2ef86df 100644
--- a/src/tls_wrappers/openssl/un_negotiate.c
+++ b/src/tls_wrappers/openssl/un_negotiate.c
@@ -9,9 +9,11 @@
 #include <rats-tls/log.h>
 #include <rats-tls/err.h>
 #include <rats-tls/tls_wrapper.h>
+#include <internal/core.h>
+#include <internal/dice.h>
 #include "openssl.h"
-#include "internal/core.h"
-#include "internal/dice.h"
+
+extern tls_wrapper_err_t openssl_tls_get_nonce(tls_wrapper_ctx_t *ctx, bool peer, void *buf, size_t *buf_size);
 
 static int rtls_memcpy_s(void *dst, uint32_t dst_size, const void *src, uint32_t num_bytes)
 {
@@ -199,6 +201,8 @@ int verify_certificate(int preverify_ok, X509_STORE_CTX *ctx)
 		return 0;
 	}
 
+	tls_wrapper_err_t t_err;
+
 	/* Get pubkey in SubjectPublicKeyInfo format from cert */
 	EVP_PKEY *pkey = X509_get_pubkey(cert);
 	if (!pkey) {
@@ -211,6 +215,16 @@ int verify_certificate(int preverify_ok, X509_STORE_CTX *ctx)
 	i2d_PUBKEY(pkey, &p);
 	EVP_PKEY_free(pkey);
 
+	/* Get nonce from sent hello */
+	uint8_t nonce_buffer[MAX_NONCE_SIZE];
+	size_t nonce_buffer_size = sizeof(nonce_buffer);
+
+	t_err = openssl_tls_get_nonce(tls_ctx, false, nonce_buffer, &nonce_buffer_size);
+	if (t_err != TLS_WRAPPER_ERR_NONE) {
+		RTLS_ERR("faild to get sent nonce %#x\n", t_err);
+		return 0;
+	}
+
 	/* Extract the RATS-TLS certificate evidence_buffer(optional for nullverifier) and endorsements_buffer(optional) from the TLS
 	 * certificate extension.
 	 */
@@ -235,8 +249,9 @@ int verify_certificate(int preverify_ok, X509_STORE_CTX *ctx)
 		return rc;
 	}
 
-	tls_wrapper_err_t t_err = tls_wrapper_verify_certificate_extension(
-		tls_ctx, pubkey_buffer, pubkey_buffer_size, evidence_buffer, evidence_buffer_size,
+	t_err = tls_wrapper_verify_certificate_extension(
+		tls_ctx, pubkey_buffer, pubkey_buffer_size, nonce_buffer, nonce_buffer_size,
+		evidence_buffer, evidence_buffer_size,
 		endorsements_buffer, endorsements_buffer_size);
 	if (t_err != TLS_WRAPPER_ERR_NONE) {
 		RTLS_ERR("failed to verify certificate extension %#x\n", t_err);
@@ -245,3 +260,18 @@ int verify_certificate(int preverify_ok, X509_STORE_CTX *ctx)
 
 	return SSL_SUCCESS;
 }
+
+int generate_certificate(SSL *ssl, void *ctx)
+{
+    RTLS_DEBUG("ssl: %p, ctx: %p\n", ssl, ctx);
+    rats_tls_err_t err;
+    tls_wrapper_ctx_t *ctx_tls = (tls_wrapper_ctx_t *) ctx; 
+
+	err = rtls_core_generate_certificate(ctx_tls->rtls_handle);
+	if (err != RATS_TLS_ERR_NONE){
+		return 0;
+	}
+
+	return 1;
+
+}
\ No newline at end of file
diff --git a/src/tls_wrappers/openssl/use_cert.c b/src/tls_wrappers/openssl/use_cert.c
index 768295d..d65d733 100644
--- a/src/tls_wrappers/openssl/use_cert.c
+++ b/src/tls_wrappers/openssl/use_cert.c
@@ -16,8 +16,8 @@ tls_wrapper_err_t openssl_tls_use_cert(tls_wrapper_ctx_t *ctx, rats_tls_cert_inf
 		return -TLS_WRAPPER_ERR_INVALID;
 
 	openssl_ctx_t *ssl_ctx = (openssl_ctx_t *)ctx->tls_private;
-	int ret = SSL_CTX_use_certificate_ASN1(ssl_ctx->sctx, cert_info->cert_len,
-					       cert_info->cert_buf);
+	int ret = SSL_use_certificate_ASN1(ssl_ctx->ssl, 
+					       cert_info->cert_buf, cert_info->cert_len);
 	if (ret != SSL_SUCCESS) {
 		RTLS_ERR("failed to use certificate %d\n", ret);
 		return OPENSSL_ERR_CODE(ret);
diff --git a/src/tls_wrappers/openssl/use_privkey.c b/src/tls_wrappers/openssl/use_privkey.c
index 447f253..ca2928e 100644
--- a/src/tls_wrappers/openssl/use_privkey.c
+++ b/src/tls_wrappers/openssl/use_privkey.c
@@ -28,7 +28,7 @@ tls_wrapper_err_t openssl_tls_use_privkey(tls_wrapper_ctx_t *ctx, rats_tls_cert_
 		return -CRYPTO_WRAPPER_ERR_UNSUPPORTED_ALGO;
 	}
 
-	int ret = SSL_CTX_use_PrivateKey_ASN1(EPKEY, ssl_ctx->sctx, privkey_buf, (long)privkey_len);
+	int ret = SSL_use_PrivateKey_ASN1(EPKEY, ssl_ctx->ssl, privkey_buf, (long)privkey_len);
 
 	if (ret != SSL_SUCCESS) {
 		RTLS_ERR("failed to use private key.\n");
diff --git a/src/verifiers/CMakeLists.txt b/src/verifiers/CMakeLists.txt
index 3f0103c..0e4cd6b 100644
--- a/src/verifiers/CMakeLists.txt
+++ b/src/verifiers/CMakeLists.txt
@@ -1,6 +1,8 @@
 add_subdirectory(nullverifier)
 
-include(FindSgxDcapQuoteVerify)
+if(HOST OR TDX OR SGX)
+    include(FindSgxDcapQuoteVerify)
+endif()
 
 if(HOST OR TDX)
     if(SGXDCAPQV_FOUND)
@@ -28,3 +30,7 @@ endif()
 if(SGX)
     add_subdirectory(sgx-la)
 endif()
+
+if(VIRTCCA)
+    add_subdirectory(virtcca)
+endif()
diff --git a/src/verifiers/internal/rtls_enclave_verifier_select.c b/src/verifiers/internal/rtls_enclave_verifier_select.c
index 217bbb7..19303ac 100644
--- a/src/verifiers/internal/rtls_enclave_verifier_select.c
+++ b/src/verifiers/internal/rtls_enclave_verifier_select.c
@@ -32,7 +32,7 @@ rats_tls_err_t rtls_verifier_select(rtls_core_context_t *ctx, const char *name,
 	RTLS_DEBUG("selecting the enclave verifier '%s' ...\n", name);
 
 	enclave_verifier_ctx_t *verifier_ctx = NULL;
-	for (unsigned int i = 0; i < enclave_verifier_nums; ++i) {
+	for (unsigned int i = 0; i < registerd_enclave_verifier_nums; ++i) {
 		RTLS_DEBUG("trying to match %s ...\n", enclave_verifiers_ctx[i]->opts->name);
 
 		if (name && strcmp(name, enclave_verifiers_ctx[i]->opts->name))
diff --git a/src/verifiers/sev-snp/pre_init.c b/src/verifiers/sev-snp/pre_init.c
index 4f9eed4..4525c3f 100644
--- a/src/verifiers/sev-snp/pre_init.c
+++ b/src/verifiers/sev-snp/pre_init.c
@@ -7,28 +7,31 @@
 #include <rats-tls/log.h>
 #include <rats-tls/verifier.h>
 
-#define TOOL_NUM 3
-#define TOOL_BUF 16
+#define TOOL_NUM  3
+#define TOOL_NAME 10
 
 enclave_verifier_err_t sev_snp_verifier_pre_init(void)
 {
 	RTLS_DEBUG("called\n");
 
-	/* These tools are used to verify SEV-SNP report */
-	const char names[TOOL_NUM][TOOL_BUF] = { "openssl", "wget", "csplit" };
-	const char parameters[TOOL_NUM][TOOL_BUF] = { "version", "-V", "--version" };
-
-	for (unsigned int i = 0; i < TOOL_NUM; ++i) {
-		char cmdline_str[64];
+	enclave_verifier_err_t err = ENCLAVE_VERIFIER_ERR_NONE;
 
-		snprintf(cmdline_str, sizeof(cmdline_str), "%s %s >/dev/null 2>&1", names[i],
-			 parameters[i]);
-
-		if (system(cmdline_str)) {
-			RTLS_ERR("Please install %s for sev_snp verifier\n", names[i]);
-			return -ENCLAVE_VERIFIER_ERR_NO_TOOL;
+	/* These tools are used to verify SEV-SNP report */
+	char tools_name[TOOL_NUM][TOOL_NAME] = { "openssl", "wget", "csplit" };
+	char cmdline_str[50] = {
+		0,
+	};
+
+	for (int i = 0; i < TOOL_NUM; i++) {
+		int count = snprintf(cmdline_str, sizeof(cmdline_str),
+				     "which %s 1> /dev/null 2> /dev/null", tools_name[i]);
+		cmdline_str[count] = '\0';
+
+		if (system(cmdline_str) != 0) {
+			RTLS_ERR("please install tool %s\n", tools_name[i]);
+			err = -ENCLAVE_VERIFIER_ERR_NO_TOOL;
 		}
 	}
 
-	return ENCLAVE_VERIFIER_ERR_NONE;
+	return err;
 }
diff --git a/src/verifiers/sev/pre_init.c b/src/verifiers/sev/pre_init.c
index ef89e57..46350e1 100644
--- a/src/verifiers/sev/pre_init.c
+++ b/src/verifiers/sev/pre_init.c
@@ -11,10 +11,13 @@ enclave_verifier_err_t sev_verifier_pre_init(void)
 {
 	RTLS_DEBUG("called\n");
 
-	if (!system("wget -V >/dev/null 2>&1"))
-		return ENCLAVE_VERIFIER_ERR_NONE;
+	enclave_verifier_err_t err = ENCLAVE_VERIFIER_ERR_NONE;
 
-	RTLS_ERR("Please install wget for sev verifier\n");
+	char *cmdline_str = "which wget 1> /dev/null 2> /dev/null";
+	if (system(cmdline_str) != 0) {
+		RTLS_ERR("please install wget for sev(-es) verify\n");
+		err = -ENCLAVE_VERIFIER_ERR_NO_TOOL;
+	}
 
-	return -ENCLAVE_VERIFIER_ERR_NO_TOOL;
+	return err;
 }
diff --git a/src/verifiers/virtcca/CMakeLists.txt b/src/verifiers/virtcca/CMakeLists.txt
new file mode 100644
index 0000000..b87d3d2
--- /dev/null
+++ b/src/verifiers/virtcca/CMakeLists.txt
@@ -0,0 +1,39 @@
+# Project name
+project(verifier_virtcca)
+
+# add_subdirectory(qcbor)
+
+# Set include directory
+set(INCLUDE_DIRS ${CMAKE_CURRENT_SOURCE_DIR}/../../include
+                 ${CMAKE_CURRENT_SOURCE_DIR}/../../include/rats-tls
+                 ${CMAKE_CURRENT_SOURCE_DIR}/../../include/internal
+                 ${CMAKE_CURRENT_SOURCE_DIR}
+                 /usr/include
+                 ./qcbor/inc
+                 )
+include_directories(${INCLUDE_DIRS})
+
+# Set dependency library directory
+set(LIBRARY_DIRS ${CMAKE_BINARY_DIR}/src
+                 ${RATS_TLS_INSTALL_LIB_PATH}
+                 )
+
+link_directories(${LIBRARY_DIRS})
+
+# Set source file
+set(SOURCES cleanup.c
+            init.c
+            main.c
+            pre_init.c
+            verify_evidence.c
+            token_parse.c
+            )
+
+# Generate library
+add_library(${PROJECT_NAME} SHARED ${SOURCES})
+target_link_libraries(${PROJECT_NAME} ${RATS_TLS_LDFLAGS} ${RTLS_LIB} qcbor)
+set_target_properties(${PROJECT_NAME} PROPERTIES VERSION ${VERSION} SOVERSION ${VERSION_MAJOR})
+
+# Install library
+install(TARGETS ${PROJECT_NAME}
+	DESTINATION ${RATS_TLS_INSTALL_LIBV_PATH})
diff --git a/src/verifiers/virtcca/cleanup.c b/src/verifiers/virtcca/cleanup.c
new file mode 100644
index 0000000..ea0f34f
--- /dev/null
+++ b/src/verifiers/virtcca/cleanup.c
@@ -0,0 +1,20 @@
+/* Copyright (c) 2021 Intel Corporation
+ * Copyright (c) 2020-2021 Alibaba Cloud
+ *
+ * SPDX-License-Identifier: Apache-2.0
+ */
+
+#include <rats-tls/log.h>
+#include <rats-tls/verifier.h>
+#include "token_parse.h"
+
+enclave_verifier_err_t virtcca_verifier_cleanup(enclave_verifier_ctx_t *ctx)
+{
+	RTLS_DEBUG("called enclave verifier ctx: %p\n", ctx);
+
+	cca_token_t *virtcca_token = (cca_token_t *)ctx->verifier_private;
+
+	free(virtcca_token);
+
+	return ENCLAVE_VERIFIER_ERR_NONE;
+}
diff --git a/src/verifiers/virtcca/init.c b/src/verifiers/virtcca/init.c
new file mode 100644
index 0000000..5e537c4
--- /dev/null
+++ b/src/verifiers/virtcca/init.c
@@ -0,0 +1,23 @@
+/* Copyright (c) 2021 Intel Corporation
+ * Copyright (c) 2020-2021 Alibaba Cloud
+ *
+ * SPDX-License-Identifier: Apache-2.0
+ */
+
+#include <rats-tls/log.h>
+#include <rats-tls/verifier.h>
+#include "token_parse.h"
+
+enclave_verifier_err_t virtcca_verifier_init(enclave_verifier_ctx_t *ctx, rats_tls_cert_algo_t algo)
+{
+	RTLS_DEBUG("ctx %p, algo %d\n", ctx, algo);
+	cca_token_buf_t *cca_token_buf = calloc(1, sizeof(cca_token_buf_t));
+
+	if (!cca_token_buf) {
+		return -ENCLAVE_ATTESTER_ERR_NO_MEM;
+	}
+
+	ctx->verifier_private = cca_token_buf;
+
+	return ENCLAVE_VERIFIER_ERR_NONE;
+}
diff --git a/src/verifiers/virtcca/main.c b/src/verifiers/virtcca/main.c
new file mode 100644
index 0000000..71d959f
--- /dev/null
+++ b/src/verifiers/virtcca/main.c
@@ -0,0 +1,33 @@
+#include <stdio.h>
+#include <rats-tls/verifier.h>
+#include <rats-tls/log.h>
+
+extern enclave_verifier_err_t enclave_verifier_register(enclave_verifier_opts_t *);
+extern enclave_verifier_err_t virtcca_verifier_pre_init(void);
+extern enclave_verifier_err_t virtcca_verifier_init(enclave_verifier_ctx_t *,
+													rats_tls_cert_algo_t algo);
+extern enclave_verifier_err_t virtcca_verify_evidence(enclave_verifier_ctx_t *,
+							   						  attestation_evidence_t *, uint8_t *,
+							   						  uint32_t hash_len,
+							   						  attestation_endorsement_t *endorsements);
+extern enclave_verifier_err_t virtcca_verifier_cleanup(enclave_verifier_ctx_t *);
+
+static enclave_verifier_opts_t virtcca_verifier_opts = {
+	.api_version = ENCLAVE_VERIFIER_API_VERSION_DEFAULT,
+	.flags = ENCLAVE_VERIFIER_OPTS_FLAGS_VIRTCCA,
+	.name = "virtcca",
+	.priority = 10,
+	.pre_init = virtcca_verifier_pre_init,
+	.init = virtcca_verifier_init,
+	.verify_evidence = virtcca_verify_evidence,
+	.cleanup = virtcca_verifier_cleanup,
+};
+
+void __attribute__((constructor)) libverifier_virtcca_init(void)
+{
+	RTLS_DEBUG("called\n");
+
+	enclave_verifier_err_t err = enclave_verifier_register(&virtcca_verifier_opts);
+	if (err != ENCLAVE_VERIFIER_ERR_NONE)
+		RTLS_ERR("failed to register the enclave verifier 'virtcca' %#x\n", err);
+}
diff --git a/src/verifiers/virtcca/pre_init.c b/src/verifiers/virtcca/pre_init.c
new file mode 100644
index 0000000..e176563
--- /dev/null
+++ b/src/verifiers/virtcca/pre_init.c
@@ -0,0 +1,15 @@
+/* Copyright (c) 2021 Intel Corporation
+ * Copyright (c) 2020-2021 Alibaba Cloud
+ *
+ * SPDX-License-Identifier: Apache-2.0
+ */
+
+#include <rats-tls/log.h>
+#include <rats-tls/verifier.h>
+
+enclave_verifier_err_t virtcca_verifier_pre_init(void)
+{
+	RTLS_DEBUG("called\n");
+
+	return ENCLAVE_VERIFIER_ERR_NONE;
+}
diff --git a/src/verifiers/virtcca/verify_evidence.c b/src/verifiers/virtcca/verify_evidence.c
new file mode 100644
index 0000000..5ed949d
--- /dev/null
+++ b/src/verifiers/virtcca/verify_evidence.c
@@ -0,0 +1,64 @@
+#include <rats-tls/log.h>
+#include <rats-tls/verifier.h>
+#include "token_parse.h"
+
+enclave_verifier_err_t virtcca_verify_evidence(enclave_verifier_ctx_t *ctx,
+						    attestation_evidence_t *evidence, uint8_t *hash, unsigned int hash_len,
+						    __attribute__((unused)) attestation_endorsement_t *endorsements)
+{
+	RTLS_DEBUG("ctx %p, evidence %p, hash %p endorsements %p\n", ctx, evidence, hash,
+		   endorsements);
+
+	int ret;
+	size_t device_cert_len;
+    uint8_t *device_cert_data;
+    cca_token_t virtcca_token = {0};
+
+	cca_token_buf_t *cca_token_buf = (cca_token_buf_t *)ctx->verifier_private;
+	memset(cca_token_buf, 0, sizeof(cca_token_buf_t));
+    memcpy(&cca_token_buf->buf_size, evidence->virtcca.report, sizeof(cca_token_buf->buf_size));
+    if (cca_token_buf->buf_size > (GRANULE_SIZE * MAX_TOKEN_GRANULE_PAGE)) {
+        RTLS_ERR("report data too long\n");
+        return ENCLAVE_VERIFIER_ERR_NO_MEM;
+    }
+
+    memcpy(cca_token_buf->buf, evidence->virtcca.report + sizeof(cca_token_buf->buf_size), cca_token_buf->buf_size);
+
+    memcpy(&device_cert_len, evidence->virtcca.report + sizeof(cca_token_buf->buf_size) + cca_token_buf->buf_size, sizeof(device_cert_len));
+
+    device_cert_data = (uint8_t *)malloc(device_cert_len);
+    if (device_cert_data == NULL) {
+        RTLS_ERR("failed to allocate memory for device_cert_data\n");
+        return ENCLAVE_VERIFIER_ERR_NO_MEM;
+    }
+    memcpy(device_cert_data, evidence->virtcca.report + sizeof(cca_token_buf->buf_size) + cca_token_buf->buf_size + sizeof(device_cert_len), device_cert_len);
+
+    // parse cca_token_buf
+    ret = parse_cca_attestation_token(&virtcca_token, cca_token_buf->buf, cca_token_buf->buf_size);
+    if (ret != VIRTCCA_SUCCESS) {
+        RTLS_ERR("failed to parse virtcca token\n");
+        free(device_cert_data);
+        return ENCLAVE_VERIFIER_ERR_CBOR;
+    }
+	print_cca_attestation_token_raw(&virtcca_token);
+    print_cca_attestation_token(&virtcca_token);
+
+	if (memcmp(virtcca_token.cvm_token.challenge.ptr, hash, hash_len)) {
+		RTLS_ERR("unmatched key binder hash value versus challenge in evidence\n");
+		return ENCLAVE_ATTESTER_ERR_INVALID;
+	}
+
+    // device_cert
+    FILE *device_cert_file = fopen("./aik_cert.der", "wb");
+    if (device_cert_file == NULL) {
+        RTLS_ERR("failed to open file for device certificate\n");
+        free(device_cert_data);
+        return ENCLAVE_ATTESTER_ERR_UNKNOWN;
+    }
+    fwrite(device_cert_data, 1, device_cert_len, device_cert_file);
+    fclose(device_cert_file);
+
+    free(device_cert_data);
+
+	return ENCLAVE_VERIFIER_ERR_NONE;
+}
\ No newline at end of file
-- 
2.37.2.windows.2

